//**********************
// FLASH Macro
// 
// (C)Copyright 2009 All rights reserved by Y.Onodera
// http://einstlab.web.fc2.com
//**********************
#include <libpic30.h>


//#define _FLASH(a) __attribute__((address(a), aligned(128)))
#define _FLASH(N) __attribute__((space(prog), aligned(N)))


// Erase FLASH 96 bytes
#define EraseFLASH(adr) \
{\
	_prog_addressT EE_addr;\
	_init_prog_address(EE_addr, adr);\
	_erase_flash(EE_addr);\
}


// from RAM(16bit x32) to FLASH(24bit x32) = 96 bytes
#define WriteFLASH(src, dst) \
{\
	_prog_addressT EE_addr;\
	_init_prog_address(EE_addr, dst);\
	_write_flash16(EE_addr, src);\
}


// from FLASH(24bit x32) to RAM(16bit x32) 64 bytes
#define ReadFLASH(src, dst) \
{\
	_prog_addressT EE_addr;\
	_init_prog_address(EE_addr, src);\
	_memcpy_p2d16(dst, EE_addr, _FLASH_ROW*2);\
}

