//**********************
// FLASH sample
//
// Condition:
// Header: FLASH.h
// Source: Sample5.c
// Library: libp30F2012-coff.a
// Linker: p30f2012.gld
//
// (C)Copyright 2009 All rights reserved by Y.Onodera
// http://einstlab.web.fc2.com
//**********************
#include <p30f2012.h>
#include "Config.h"
#include "FLASH.h"


// FLASH data by alignment=64 96bytes
int _FLASH(64) a[32] = {0x0,0x1,0x2,0x3,0x4,0x5,0x6,0x7,0x8,0x9,0xA,0xB,0xC,0xD,0xE,0xF,
                        0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F};

// RAM data, 16bit x32
int b[32];

// Main routine
int main(void)
{

	ReadFLASH(a, b);	// 24bit x32 -> 16bit x32 = 128bytes
	EraseFLASH(a);		// 24bit x32 = 96bytes
	WriteFLASH(b, a);	// 16bit x32 -> 24bit x32 = 96bytes
	ReadFLASH(a, b);	// 24bit x32 -> 16bit x32 = 128bytes

	while(1){}

}

